=== meson_options.txt ===
option(
    'test',
    type : 'boolean',
    value : true,
    description : 'Build and run tests'
)

option(
    'hash',
    type : 'boolean',
    value : false,
    description : 'Do hashing at build time - longer build times, but O(1) string lookup'
)
