=== debian/changelog ===
magic-enum (0.9.5-2) unstable; urgency=medium

  * Mark libmagicenum-dev as Multi-Arch: foreign
  * Add autopkgtest using examples

 -- Stephan Lachnit <stephanlachnit@debian.org>  Fri, 09 Feb 2024 17:04:33 +0100

magic-enum (0.9.5-1) unstable; urgency=medium

  * Initial release (Closes: #1055706)

 -- Stephan Lachnit <stephanlachnit@debian.org>  Thu, 25 Jan 2024 16:43:46 +0100
