=== debian/watch ===
version=4
https://github.com/Neargye/magic_enum/tags (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
