=== debian/changelog ===
magic-enum (0.9.6-1) unstable; urgency=medium

  * New upstream version 0.9.6
  * Update standards version to 4.7.0

 -- Stephan Lachnit <stephanlachnit@debian.org>  Thu, 01 Aug 2024 09:25:01 +0200
