=== debian/changelog ===
magic-enum (0.9.7-1) unstable; urgency=medium

  * New upstream version 0.9.7
  * Update standards version to 4.7.2

 -- Stephan Lachnit <stephanlachnit@debian.org>  Thu, 10 Apr 2025 20:46:37 +0200
