=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
 Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/Neargye/magic_enum
 Vcs-Git: https://salsa.debian.org/debian/magic-enum.git
 Vcs-Browser: https://salsa.debian.org/debian/magic-enum
