=== debian/tests/control ===
Tests: examples
Depends: @, build-essential, cmake, ninja-build
